var p_image_uploader = {
	uploadFile: [], // 需要上传的文件数组
	lastUploadFile: [], // 上一次选择的文件数组，方便继续上传使用
	perUploadFile: [], // 存放永久的文件数组，方便删除使用
	fileNum: 0, // 代表文件总个数，因为涉及到继续添加，所以下一次添加需要在它的基础上添加索引
	userDom:null,//引用的DOM节点

	reInit: function() {
		this.uploadFile = [];
		this.lastUploadFile = [];
		this.perUploadFile = [];
		this.fileNum = 0;
	},
	// 获取文件
	funGetFiles: function(e) {
		var self = this;
		// 从事件中获取选中的所有文件
		var files = e.target.files || e.dataTransfer.files;
		self.lastUploadFile = this.uploadFile;
		this.uploadFile = files;
		var tmpFiles = [];

		// 因为jquery的inArray方法无法对object数组进行判断是否存在于，所以只能提取名称进行判断
		var lArr = []; // 之前文件的名称数组
		var uArr = []; // 现在文件的名称数组
		$.each(self.lastUploadFile, function(k, v) {
			lArr.push(v.name);
		});
		$.each(self.uploadFile, function(k, v) {
			uArr.push(v.name);
		});

		$.each(uArr, function(k, v) {
			// 获得当前选择的每一个文件   判断当前这一个文件是否存在于之前的文件当中
			if($.inArray(v, lArr) < 0) { // 不存在
				tmpFiles.push(self.uploadFile[k]);
			}
		});
		this.uploadFile = tmpFiles;
		// 调用对文件处理的方法
		this.funDealtFiles();
		return true;
	},
	// 处理过滤后的文件，给每个文件设置下标
	funDealtFiles: function() {
		var self = this;
		// 目前是遍历所有的文件，给每个文件增加唯一索引值
		$.each(this.uploadFile, function(k, v) {
			// 因为涉及到继续添加，所以下一次添加需要在总个数的基础上添加
			v.index = self.fileNum;
			// 添加一个之后自增
			self.fileNum++;
		});
		// 先把当前选中的文件保存备份
		var selectFile = this.uploadFile;
		// 要把全部的文件都保存下来，因为删除所使用的下标是全局的变量
		this.perUploadFile = this.perUploadFile.concat(this.uploadFile);
		// 合并下上传的文件
		this.uploadFile = this.lastUploadFile.concat(this.uploadFile);

		console.info("继续选择");
		console.info(this.uploadFile);
		return this;
	},
	// 处理需要删除的文件  isCb代表是否回调onDelete方法  
	funDeleteFile: function(delFileIndex) {
		var self = this; // 在each中this指向没个v  所以先将this保留

		var tmpFile = []; // 用来替换的文件数组
		// 合并下上传的文件
		var delFile = this.perUploadFile[delFileIndex];
		//console.info(delFile);
		// 目前是遍历所有的文件，对比每个文件  删除
		$.each(this.uploadFile, function(k, v) {
			if(delFile != v) {
				// 如果不是删除的那个文件 就放到临时数组中
				tmpFile.push(v);
			}
		});
		this.uploadFile = tmpFile;
		
		$("#uploadList_" + delFileIndex).remove();
		var div_height = 28;
		if(this.uploadFile.length > 3) {
			div_height = 28 * Math.ceil((this.uploadFile.length + 1) / 4);
		}
		$(this.userDom).height(div_height+'vw');
		console.info("还剩这些文件没有上传:");
		console.info(this.uploadFile);
		return true;
	},
	// 返回需要上传的文件
	funReturnNeedFiles: function() {
		return this.uploadFile;
	},
};
(function($) {
	getBlob = function(buffer, format) {
		try {
			return new Blob(buffer, {
				type: format
			});
		} catch(e) {
			var bb = new(window.BlobBuilder || window.WebKitBlobBuilder || window.MSBlobBuilder);
			buffer.forEach(function(buf) {
				bb.append(buf);
			});
			return bb.getBlob(format);
		}
	};

	$.fn.h5ImageUpload = function(options) {
		p_image_uploader.reInit();
		var img_dom = this;
		p_image_uploader.userDom=this;
		var para = {};
		var defaults = {
			itemWidth: "100px", // 文件项的宽度
			itemHeight: "100px", // 文件项的高度
			multiple: true, // 是否可以多个文件上传
			name: 'img_input',
		};

		// 绑定删除按钮事件
		var funBindDelEvent = function() {
			if($(".pet-file_del").length > 0) {
				// 删除方法
				$(".pet-file_del").click(function() {
					p_image_uploader.funDeleteFile(parseInt($(this).attr("data-index")));
					return false;
				});
			}
		};
		para = $.extend(defaults, options);
		return this.each(function() {
			this.createHtml = function() {
				var multiple = "";
				// 设置多选的参数
				para.multiple ? multiple = "multiple" : multiple = "";
				var html = '';
				var imgWidth = para.itemWidth;

				html += '<input id="' + para.name + '" name="' + para.name + '" style="display: none;" type="file" accept="image/*" ' + multiple + '>';
				html += '<div id="preview_box" class="pet-preview-image">';
				html += '<label for="' + para.name + '" id="img_label" class="pet-imageBox"  style="height:' + para.itemHeight + ';width:' + para.itemWidth + ';">';
				html += '<i class="iconfont pet-img-uploader-icon">&#xe611;</i>';
				
				html += '</label>';
				html += '</div>';

				$(this).append(html);

				// 初始化html之后绑定按钮的点击事件
				$("#" + para.name).on("change", function(e) {
					p_image_uploader.funGetFiles(e);
					var div_height = 28;
					if(p_image_uploader.uploadFile.length > 3) {
						div_height = 28 * Math.ceil((p_image_uploader.uploadFile.length + 1) / 4);
					}
					$(img_dom).height(div_height+'vw');

					$("img[id^='uploadList_']").remove();

					$.each(p_image_uploader.uploadFile, function(key, value) {
						var file = value;
						//获取图片资源
						var fileType = file.type;
						var reader = new FileReader();
						// 读取文件
						reader.readAsArrayBuffer(file);
						// 渲染文件
						reader.onload = function(arg) {
							var blob = getBlob([arg.target.result], fileType);
							var url = URL.createObjectURL(blob);
							var img = '<div class="upload_append_list"><div class="pet-file_bar"><span class="pet-file_del"  data-index="' + file.index + '" title="删除"><i class="iconfont">&#xe609;</i></span></div><img  id="uploadList_' + file.index + '" class="pet-single-image" style="height:' + para.itemHeight + ';width:' + para.itemWidth + ';" src="' + url + '" alt="' + file.name + '"/></div>';
							$("#img_label").before(img);
							funBindDelEvent();
						}
					});

				});
			};

			this.createHtml();
		});

	};

})(jQuery);