/*******************************************************************************
 * Copyright (c) 2016 Auto517
 * Date     :2016-10-17
 * Desc     :F7的Ajax预处理、错误处理、完成处理
 * Author   :Tuatua
 *******************************************************************************/
/**
 *  @namespace Auto517.Ajax
 *  Method:
 *  Auto517.Ajax();
 */
var _p_ajax = function() {
		//ajax使用开关，'F7' or 'api'
		var _switch = 'F7';
		var _logOut = function() {
			toast.show("您的账号已经在其他设备上登录！");
			window.localStorage.setItem("uuid", "");
			window.localStorage.setItem("cellphone", "");
			window.localStorage.setItem("News", "");
			Mine.userinfo = {};
			globalVar.uuid = null;
			globalVar.cellphone = null;
			Auto517.Ajpush.startNotification('logout');
			mainView.router.loadPage("html/user/login.html");
		};
		/**
		 * 平台ajax公共方法
		 * @param {Object} params
		 */
		var _ajaxBus = function(params) {
			var a_param = params.data;
			if(typeof(api) != "undefined") {
				//设备唯一标识
				a_param['deviceId'] = api.deviceId;
			} else {
				a_param['deviceId'] = 'is-not-android-or-ios';
			}
			a_param['cellphone'] = globalVar.cellphone;
			

			var a_url = params.url;
			var a_method = params.method||'GET';
			var a_dataType = params.dataType||'json';
			var a_timeout = params.timeout||'15000';
			var a_success = params.success;
			var a_beforeSend = params.beforeSend || function() {};
			var a_complete = params.complete || function() {};
			var a_error = params.error || function() {};

			if(_switch == 'F7') {
				$$.ajax({
					method: a_method,
					url: a_url,
					data: a_param,
					dataType: a_dataType,
					timeout: a_timeout,
					success: function(data) {
						if(data.loginDuplicate != null && data.loginDuplicate == true) {
							_logOut();
						} else {
							a_success(data);
						}

					},
					beforeSend: a_beforeSend,
					error: a_error,
					complete: a_complete,
				});
			} else {
				if(a_timeout != null) {
					a_timeout = parseInt(a_timeout / 1000);
				} else {
					a_timeout = 30;
				}
				a_beforeSend();
				api.ajax({
					url: a_url,
					method: a_method,
					dataType: a_dataType,
					timeout: a_timeout,
					certificate: {
						path: '', //p12证书路径，支持fs://、widget://、cache://等文件路径协议，字符串类型
						password: '' //证书密码，字符串类型
					},
					data: {
						values: a_param
					}
				}, function(ret, err) {
					if(ret) {
						console.log('API AJAX SUCCESS:' + JSON.stringify(ret) + ' ' + JSON.stringify(err));
						if(ret.loginDuplicate != null && ret.loginDuplicate == true) {
							_logOut();
						} else {
							a_success(ret);
						}
						a_complete(null, 200);
					} else {
						console.log('API AJAX ERROR:' + JSON.stringify(ret) + ' ' + JSON.stringify(err));
						if(err.code == 0) {
							toast.show('连接错误');
						} else if(err.code == 1) {
							toast.show('超时');
						} else if(err.code == 2) {
							toast.show('授权错误');
						} else if(err.code == 3) {
							toast.show('数据类型错误');
						}
						$$('.ajaxPreLoader').css('display', 'none');

					}

				});
			}
		};
		//
		var _beforeSendFun = function(xhr, status) {
				//petKiki.showIndicator();
				$$('.ajaxPreLoader').css('display', 'block');
				//$$('.page').toggleClass('disabledPage');
			}
			//
		var _completeFun = function(xhr, status) {
				console.info('HTTP Request=', xhr, status);
				if(status == '200' || status == 200) {
					petKiki.hideIndicator();
					//$$('.page').toggleClass('disabledPage');
					$$('.ajaxPreLoader').css('display', 'none');
				}
			}
			//
		var _errorFun = function(xhr, status) {
				console.log('function in error=' + JSON.stringify(xhr) + ' ' + status, xhr);
				if(status == 'timeout') {
					toast.show('请求超时');
					petKiki.hideIndicator();
					$$('.ajaxPreLoader').css('display', 'none');
				}

				if(status == '0' || status == 0) {
					toast.show('服务器开小差，请稍后再试啦');
					petKiki.hideIndicator();
					$$('.ajaxPreLoader').css('display', 'none');
				}

				if(status == '500' || status == 500 || status == '404' || status == 404) {
					toast.show('服务器错误！');
					petKiki.hideIndicator();
					$$('.ajaxPreLoader').css('display', 'none');
				}

				if(status == 'parseerror') {
					toast.show('数据异常！');
					petKiki.hideIndicator();
					$$('.ajaxPreLoader').css('display', 'none');
				}
			}
			//
		return {
			"ajaxBus": _ajaxBus,
			"beforeSendFun": _beforeSendFun,
			"completeFun": _completeFun,
			"errorFun": _errorFun
		};
	}
	//
Auto517.regist(_p_ajax, "Ajax");