/**
 * 寻宠列表
 */
petKiki.onPageInit('myfocus', function(page) {
	//绑定去发布链接，同时判断用户是否登录
	$$('#goPublish').on('click', function(e) {
		if (globalVar.uuid == null && (window.localStorage.getItem('uuid') == null || window.localStorage.getItem('uuid') == '')) {
			petKiki.confirm('去注册／登录?', '需要登录后才能发布寻宠信息', function() {
				mainView.router.loadPage("html/user/login.html");
			});
		} else {
			mainView.router.loadPage('html/discovery/publish.html');
		}
	});

	//初始化列表
	Focus.loadDiscoveryData(1, null);

	// 下拉刷新监听器
	$$('#refreshDiscovery').on('refresh', function(e) {
		$$('.pull-loader').css('display', 'block');
		// 模拟2s的加载过程
		setTimeout(function() {
			Focus.loadDiscoveryData(2, null);
			// 加载完毕需要重置
			petKiki.pullToRefreshDone();
			$$('.pull-loader').css('display', 'none');
		}, 2000);
	});

	// 加载flag
	var loading = false;
	// 最多可加载的条目
	var maxItems = 1000;
	// 每次加载添加多少条目
	var itemsPerLoad = 10;
	// 注册'infinite'事件处理函数
	$$('#refreshDiscovery').on('infinite', function() {
		$$('.infinite-scroll-preloader').show();
		// 如果正在加载，则退出
		if (loading)
			return;
		// 设置flag
		loading = true;
		// 模拟1s的加载过程
		setTimeout(function() {
			// 上次加载的序号
			var lastIndex = $$('#discoveryListData>a').length;
			// 重置加载flag
			loading = false;
			if (lastIndex >= maxItems) {
				// 加载完毕，则注销无限加载事件，以防不必要的加载
				petKiki.detachInfiniteScroll($$('#refreshDiscovery'));
				// 删除加载提示符
				$$('.infinite-scroll-preloader').remove();
				return;
			}
			// 时间戳c_createtime
			var lastEle = $$("#discoveryListData").children("a:last-child");
			var lastEleTime = lastEle.find('input[name=c_createtime]').val();
			// 生成新条目的HTML
			Focus.loadDiscoveryData(3, lastEleTime);

			// 更新最后加载的序号
			lastIndex = $$('#discoveryListData>a').length;
		}, 1000);
	});
	//
	$$('.center').on('click', scrollTop);
});
//
/**
 * 查看寻宠详情
 */
petKiki.onPageInit('viewMyfocus', function(page) {
	var oid = page.query.c_noticeid;
	var userid = page.query.userid;

	Focus.noticeId = oid;
	window.Auto517.Ajax.ajaxBus({
		url : globalVar.serverAddress + '/findPetNotice/getFindPetDetail.jhtml?fromChannel=app',
		dataType : 'json',
		timeout : 150000,
		data : {
			c_userid : globalVar.uuid,
			c_noticeid : oid,
			c_longitude_n : globalVar.location.lon,
			c_latitude_n : globalVar.location.lat
		},
		type : 'get',
		success : function(data) {
			var currentDt = new Date().Format("yyyy-MM-dd hh:mm:ss");
			//寻宠启示
			var caption = data.notice.c_content;
			var petSex = data.notice.c_petsex;
			var isCare = data.careFlag;

			//寻宠基本信息
			var baseInfo = '';
			baseInfo += '<div class="pet-title-card discovery-card">';
			baseInfo += '<div class="discovery-card-header">';
			baseInfo += '<div class="discovery-avatar"><img src="' + globalVar.serverAddress + '/upload/' + data.notice.c_headimge + '" /></div>';
			baseInfo += '<div class="discovery-detail-cardtitle"><span>' + data.notice.c_nickname + '</span>';

			baseInfo += '<div class="discovery-detail-lefttitle" id="findPetCare">';
			if (isCare == "1") {
				baseInfo += '<div onclick="Focus.setCare(' + oid + ', 0)"><i class="iconfont" style="font-size: 18px;">&#xe60d;</i>已关注</div>';
			} else {
				baseInfo += '<div onclick="Focus.setCare(' + oid + ', 1)"><i class="iconfont" style="font-size: 18px;">&#xe61b;</i>未关注</div>';
			}
			baseInfo += '</div>';

			baseInfo += '</div>';
			baseInfo += '<div class="discovery-detail-cardsubtitle"><span>' + data.notice.petName + '｜' + data.notice.c_petage + '｜' + data.notice.c_petvariety + '</span>';
			if (petSex == '1') {
				baseInfo += '<i class="iconfont pet-detail-bule-style">&#xe607;</i></div></div>';
			} else {
				baseInfo += '<i class="iconfont pet-detail-red-style">&#xe606;</i></div></div>';
			}

			baseInfo += '<div class="discovery-card-footer">';
			baseInfo += '<div class="footer-left"><i class="iconfont discovery-eye-icon">&#xe61c;</i><span class="pet-footer-data">' + data.notice.c_browsenum + '</span></div>';
			baseInfo += '<div class="footer-left"><i class="iconfont discovery-message-icon">&#xe608;</i><span class="pet-footer-data">' + data.notice.c_commentnum + '</span></div>';
			baseInfo += '<div class="footer-right"><i class="iconfont discovery-time-icon">&#xe60b;</i><span class="pet-footer-data">' + Auto517.Date.getDiffLabel(data.notice.c_createtime, currentDt) + '</span></div>';
			baseInfo += '<div class="footer-right"><i class="iconfont discovery-location-icon">&#xe601;</i><span class="pet-footer-data">' + data.notice.distance + '</span></div>';
			baseInfo += '</div>';
			baseInfo += '</div>';

			var pictureNumber = data.picture.length;
			baseInfo += '<div class="pet-detail-card">';
			baseInfo += '<div class="card-detail-content">';

			if (pictureNumber > 0) {
				baseInfo += '<div style="background-image:url(' + globalVar.serverAddress + '/upload/' + data.picture[0].c_picture + ')" valign="bottom" class="card-bigphoto">';
				baseInfo += '<div class="img-total">' + pictureNumber + '张</div>';
				baseInfo += '</div>';
			}
			baseInfo += '</div>';
			baseInfo += '<div class="card-detail-footer">';
			baseInfo += '<div class="row">';
			baseInfo += '<div class="col-50">';
			baseInfo += '<div class="card-detail-seal"><img class="seal-logo" src="image/guarantee.png" /></div>';
			baseInfo += '<div class="detail-money"><span class="detail-money-desc">酬金¥</span><span class="detail-money-num">' + data.notice.c_money + '</span></div>';
			baseInfo += '</div>';
			baseInfo += '<div class="col-50">';
			if (data.notice.c_status == '5') {
				baseInfo += '<div class="pet-btn-findover">已寻回</div>';
			} else {
				baseInfo += '<div class="pet-btn-surefind" id="pet-btn-surefind">确认寻得</div>';
			}
			baseInfo += '</div>';
			baseInfo += '</div>';

			baseInfo += '</div>';
			baseInfo += '</div>';
			baseInfo += '<div class="pet-sortline"></div>';
			baseInfo += '<div class="pet-detail-block">';
			baseInfo += '<div class="row pet-detail-doginfo">';
			baseInfo += '<div class="col-50">品种<span class="pet-info-data">' + data.notice.c_petvariety + '</span></div>';
			baseInfo += '<div class="col-50">年龄<span class="pet-info-data">' + data.notice.c_petage + '</span></div>';
			baseInfo += '</div>';
			baseInfo += '<div class="row pet-detail-doginfo">';
			if (petSex == '1') {
				baseInfo += '<div class="col-50">性别<span class="pet-info-data">男宠</span></div>';
			} else {
				baseInfo += '<div class="col-50">性别<span class="pet-info-data">女宠</span></div>';
			}

			baseInfo += '<div class="col-50">丢失时间<span class="pet-info-data">' + Auto517.Date.getDiffLabel(data.notice.c_happentime, currentDt) + '</span></div>';
			baseInfo += '</div>';
			baseInfo += '<div class="row pet-detail-doginfo">';
			baseInfo += '<div class="col-100">丢失地点<span class="pet-info-data">' + data.notice.c_adddress + '</span></div>';
			baseInfo += '</div>';
			baseInfo += '</div>';
			baseInfo += '<div class="pet-sortline"></div>';
			baseInfo += '<div class="pet-find-description"><span>' + caption + '</span>';
			baseInfo += '</div>';

			$$('#myfocus-find-pet-info').html(baseInfo);

			var photoBrowserPhotos = [];

			for (var j = 0; j < pictureNumber; j++) {
				photoBrowserPhotos.push({
					url : globalVar.serverAddress + '/upload/' + data.picture[j].c_picture,
					caption : caption
				});
			}
			/*
			 var photoBrowserPopupDark = petKiki.photoBrowser({
			 photos: photoBrowserPhotos,
			 theme: 'dark',
			 iconsColor: 'pink'
			 });
			 */
			$$('.card-bigphoto').on('click', function() {
				Disvovery.photoBrowserPopupDark = petKiki.photoBrowser({
					photos : photoBrowserPhotos,
					theme : 'dark',
					iconsColor : 'pink'
				});
				Disvovery.photoBrowserPopupDark.open();
			});
			//绑定“确认寻得”按钮点击事件
			$$('#pet-btn-surefind').on('click', function() {
				if (globalVar.uuid == null && (window.localStorage.getItem('uuid') == null || window.localStorage.getItem('uuid') == '')) {
					petKiki.confirm('马上去注册／登录？', '需要先登录', function() {
						mainView.router.loadPage("html/user/login.html");
					});
				} else {
					//获取寻宠进度
					window.Auto517.Ajax.ajaxBus({
						method : 'get',
						url : globalVar.serverAddress + '/findPetNotice/checkStatus.jhtml?fromChannel=app',
						data : {
							c_userid : globalVar.uuid,
							c_noticeid : oid
						},
						dataType : 'json',
						timeout : 150000,
						success : function(data) {
							console.log('点击确认寻得按钮' + JSON.stringify(data));
							if (data.status == '1' || data.status == '2') {
								//只有1、寻宠进行中的记录或2、寻得宠物的人，才能进入确认寻得页面
								mainView.router.loadPage("html/discovery/sureFind.html?c_status=" + data.c_status + '&c_noticeid=' + oid);
							} else {
								toast.show('该宠物已经有人寻得');
							}

						},
						error : window.Auto517.Ajax.errorFun,
					});
				}
			});

			//渲染评论数据
			var commentDATA = data.comment;
			if (commentDATA.length > 0) {
				var commentArea = '';
				for (var k = 0; k < commentDATA.length; k++) {
					commentArea += Focus.commmentCardTemplate(commentDATA[k]);
				}
				$$('#find-pet-comment').html(commentArea);
			}
			//绑定拨打失主电话
			$$('#callLoster').on('click', function() {
				window.Auto517.Ajax.ajaxBus({
					method : 'get',
					url : globalVar.serverAddress + '/findPetNotice/getIsContact.jhtml?fromChannel=app',
					data : {
						c_userid : globalVar.uuid,
						c_noticeid : oid
					},
					dataType : 'json',
					timeout : 150000,
					success : function(data) {
						if (data.status == '1') {
							Disvovery.callLoster(data.notice.c_contacttel);
						} else {
							petKiki.alert('<span style="font-size:17px;color:#333">您还未验证二维码</span><br/><span style="font-size:17px;color:#333">暂时无法与狗主人联系</span>');
						}

					},
					error : window.Auto517.Ajax.errorFun,
				});

			});

		},
		beforeSend : window.Auto517.Ajax.beforeSendFun,
		error : window.Auto517.Ajax.errorFun,
		complete : window.Auto517.Ajax.completeFun,
	});

	//绑定直接评论按钮
	$$('#writeComment').on('click', function() {
		Focus.popupComment("0", userid);
	});
	//
	$$('.center').on('click', scrollTop);
});
//
var Focus = {
	'myPhotoBrowserStandalone' : null,
	'beCommentator' : 0, //基于哪条评论做的回复？如果直接评论默认评论id就是0.
	'noticeId' : 0, //寻宠详情的ID
	'receiveId' : 0, //对话者，如果直接评论，值就是发布寻宠人的ID；如果是回复的某条评论，值就是评论记录的发表人ID
	'showShare' : function() {
		$$('#share_content').removeClass('modal-out');
		$$('#share_content').addClass('modal-in');
		$$('#pet_share').addClass('modal-overlay-visible');

	},

	'closeShare' : function() {
		$$('#share_content').addClass('modal-out');
		$$('#share_content').removeClass('modal-in');
		$$('#pet_share').removeClass('modal-overlay-visible');
	},
	'callLoster' : function(phoneNumber) {
		api.call({
			type : 'tel_prompt',
			number : phoneNumber
		});
	},
	//地址解析回调函数
	'addressConvert' : function(address, params) {
		if (params.status == true) {
			$$('#lostLon').attr('value', params.lon);
			$$('#lostLat').attr('value', params.lat);
			$$('#chooseLocation').attr('value', address);
			mainView.router.back();
		} else {
			toast.show('请输入包含:市、区的详细地址');
		}
	},
	//
	'canclePublish' : function(noticeid) {
		petKiki.confirm('确认取消发布', function() {
			window.Auto517.Ajax.ajaxBus({
				url : globalVar.serverAddress + '/findPetNotice/cancelFindPet.jhtml?fromChannel=app',
				dataType : 'json',
				timeout : 150000,
				data : {
					c_userid : globalVar.uuid,
					c_noticeid : noticeid
				},
				type : 'post',
				success : function(data) {
					var status = data.status;
					//
					if (status == '1' || status == 1) {
						toast.show('取消发布成功');
					}
					//
					if (status == '0' || status == 0) {
						toast.show('取消发布失败');
					}
					//
					mainView.router.loadPage('html/user/user.html');
				},
				beforeSend : window.Auto517.Ajax.beforeSendFun,
				error : window.Auto517.Ajax.errorFun,
				complete : window.Auto517.Ajax.completeFun,
			});
		});
	},
	'confirmPublish' : function(noticeid) {
		petKiki.alert('暂时不支持，待功能开发完成后');
	},
	/**
	 * 发现页面加载列表数据
	 * @param {Object} flag  1:页面初始化 2:下拉刷新呢 3:无限加载
	 * @param {Object} timemark 时间戳
	 */
	'loadDiscoveryData' : function(flag, timemark) {
		window.Auto517.Ajax.ajaxBus({
			url : globalVar.serverAddress + '/findpetcare/listMyCare.jhtml?fromChannel=app',
			dataType : 'json',
			timeout : 150000,
			data : {
				c_userid : globalVar.uuid,
				timemark : timemark,
				c_longitude_n : globalVar.location.lon,
				c_latitude_n : globalVar.location.lat
			},
			type : 'post',
			success : function(data) {
				var discoveryList = data._rows;
				var itemHTML = '';
				if (discoveryList.length > 0) {
					var currentDt = new Date().Format("yyyy-MM-dd hh:mm:ss");
					for (var i = 0; i < discoveryList.length; i++) {
						itemHTML += '<a href="html/user/myfocus/viewMyfocus.html?c_noticeid=' + discoveryList[i].c_id + '&userid=' + discoveryList[i].c_userid + '" class="item-link">';
						itemHTML += '<input type="hidden" name="c_createtime" value="' + discoveryList[i].c_createtime + '"/>';
						itemHTML += '<div class="discovery-card">';
						itemHTML += '<div class="seal"><img class="seal-logo" src="image/guarantee.png" /></div>';
						itemHTML += '<div class="discovery-card-header">';
						itemHTML += '<div class="discovery-avatar"><img src="' + globalVar.serverAddress + '/upload/' + discoveryList[i].c_headimge + '" /></div>';
						itemHTML += '<div class="discovery-name">' + discoveryList[i].c_nickname + '</div>';
						if (discoveryList[i].c_status == '5') {
							itemHTML += '<div class="discovery-label label-yellow"><span class="text">已寻回</span></div>';
						} else {
							itemHTML += '<div class="discovery-label label-red"><span class="text">寻宠中</span></div>';
						}
						itemHTML += '<div class="discovery-money"><span class="money-des">酬金¥</span><span class="money-number">' + discoveryList[i].c_money + '</span></div>';
						itemHTML += '</div>';
						itemHTML += '<div class="discovery-card-content">';
						itemHTML += '<div class="des-text">' + discoveryList[i].c_content + '</div>';
						itemHTML += '<div class="des-picture">';
						itemHTML += '<div class="row">';
						var imgs = discoveryList[i].picture;
						if (imgs.length > 0) {
							if (imgs[0] != null) {
								itemHTML += '<div class="des-img" style="background-image:url(' + globalVar.serverAddress + '/upload/' + imgs[0].c_smallpicture + ')"></div>';
							} else {
								itemHTML += '<div class="des-img"></div>';
							}
							if (imgs[1] != null) {
								itemHTML += '<div class="des-img" style="background-image:url(' + globalVar.serverAddress + '/upload/' + imgs[1].c_smallpicture + ')"></div>';
							} else {
								itemHTML += '<div class="des-img"></div>';
							}
							if (imgs[2] != null) {
								itemHTML += '<div class="des-img" style="background-image:url(' + globalVar.serverAddress + '/upload/' + imgs[2].c_smallpicture + ')"></div>';
							} else {
								itemHTML += '<div class="des-img"></div>';
							}
						}
						itemHTML += '</div>';
						itemHTML += '</div>';
						itemHTML += '</div>';
						itemHTML += '<div class="discovery-card-footer">';
						itemHTML += '<div class="footer-left"><i class="iconfont discovery-heart-icon">&#xe60d;</i><span class="pet-footer-data">' + discoveryList[i].c_carenum + '</span></div>';
						itemHTML += '<div class="footer-left"><i class="iconfont discovery-eye-icon">&#xe61c;</i><span class="pet-footer-data">' + discoveryList[i].c_browsenum + '</span></div>';
						itemHTML += '<div class="footer-left"><i class="iconfont discovery-message-icon">&#xe608;</i><span class="pet-footer-data">' + discoveryList[i].c_commentnum + '</span></div>';
						itemHTML += '<div class="footer-right"><i class="iconfont discovery-time-icon">&#xe60b;</i><span class="pet-footer-data">' + Auto517.Date.getDiffLabel(discoveryList[i].c_createtime, currentDt) + '</span></div>';
						itemHTML += '<div class="footer-right"><i class="iconfont discovery-location-icon">&#xe601;</i><span class="pet-footer-data">' + discoveryList[i].distance + '</span></div>';
						itemHTML += '</div>';
						//
						itemHTML += '</div>';
						itemHTML += '</a>';
					}
				}
				if (flag == 3) {
					$$('#discoveryListData').append(itemHTML);
				} else {
					$$('#discoveryListData').html(itemHTML);
				}
			},
			error : window.Auto517.Ajax.errorFun,
			complete : function(xhr, status) {
				if (flag == 3) {
					$$('.infinite-scroll-preloader').hide();
				}
			},
		});
	},
	//弹出评论输入框
	'popupComment' : function(commentId, receiveId) {
		if (globalVar.uuid == null && (window.localStorage.getItem('uuid') == null || window.localStorage.getItem('uuid') == '')) {
			petKiki.confirm('去注册／登录?', '需要登录后才能评论', function() {
				mainView.router.loadPage("html/user/login.html");
			});
		} else {
			this.beCommentator = commentId;
			this.receiveId = receiveId;

			// Check first, if we already have opened picker
			if ($$('.picker-modal.modal-in').length > 0) {
				petKiki.closeModal('.picker-modal.modal-in');
			}
			petKiki.pickerModal('<div class="picker-modal" style="background-color: rgb(247,247,247);">' + '<div class="toolbar" style="border-bottom: 1px solid rgb(228,228,228);">' + '<div class="toolbar-inner">' + '<div class="left" style="padding-left: 10px;"><a href="#" class="close-picker">取消</a></div>' + '<div class="right" id="focus_send_comment" style="padding-right: 10px;" onclick="Focus.saveComment();">发送</div>' + '</div>' + '</div>' + '<textarea class="pet-write-comment-textarea" placeholder="输入评论内容"></textarea>' + '</div>');
			$$('#focus_send_comment').removeAttr("disabled");
		}

	},
	//保存评论
	'saveComment' : function() {
		var content = utf16toEntities($$('.pet-write-comment-textarea').val().replace(/(^\s*)|(\s*$)/g, ""));
		if (content == null || content == undefined || content == '') {
			toast.show('请输入评论内容');
			return false;
		}
		if (content.length > 200) {
			toast.show('评论字数不能超过200字');
			return false;
		}
		$$('#focus_send_comment').attr("disabled", "disabled");
		//过滤敏感字
		wordpass(content);
		api.addEventListener({
			name : 'getKeyWord'
		}, function(ret, err) {

			content = ret.value.info;

			window.Auto517.Ajax.ajaxBus({
				url : globalVar.serverAddress + '/findpetComment/addComment.jhtml?fromChannel=app',
				dataType : 'json',
				timeout : 150000,
				data : {
					c_userid : globalVar.uuid,
					c_receiveid : Focus.receiveId,
					c_content : content,
					c_noticeid : Focus.noticeId,
					c_commentid : Focus.beCommentator

				},
				type : 'post',
				success : function(data) {
					console.log("评论发表成功");
					petKiki.closeModal('.picker-modal.modal-in');
					$$('#find-pet-comment').prepend(Focus.commmentCardTemplate(data.comment));
				},
				beforeSend : window.Auto517.Ajax.beforeSendFun,
				error : window.Auto517.Ajax.errorFun,
				complete : window.Auto517.Ajax.completeFun,
			});
		})
	},
	'commmentCardTemplate' : function(jsonObj) {
		var commentHTML = '';
		commentHTML += '<div class="pet-comment-content">';
		commentHTML += '<div class="row">';
		commentHTML += '<div class="col-80"><img src="' + globalVar.serverAddress + '/upload/' + jsonObj.c_headimge + '"><span class="pet-comment-user">' + jsonObj.c_nickname + '</span></div>';
		if ((parseInt(jsonObj.c_floor) - 1) == 0) {
			commentHTML += '<div class="col-20"><span class="pet-comment-floor">沙发</span></div>';
		} else {
			commentHTML += '<div class="col-20"><span class="pet-comment-floor">' + jsonObj.c_floor + '楼</span></div>';
		}

		commentHTML += '</div>';
		commentHTML += '<div class="pet-comment-text">' + jsonObj.c_content + '</div>';

		var c_userid_p = jsonObj.c_userid_p;
		if (c_userid_p != null) {
			commentHTML += '<div class="pet-comment-talkto">';
			commentHTML += '<div class="talkto-title">｜' + jsonObj.c_nickname_p + ' ' + jsonObj.c_createtime_p + ' 发表在 ' + jsonObj.c_floor_p + '楼</div>';
			commentHTML += '<div class="talkto-content">' + jsonObj.c_content_p + '</div>';
			commentHTML += '</div>';
		}

		commentHTML += '<div class="row pet-comment-footer">';
		commentHTML += '<div class="col-60"><span class="pet-comment-time">' + jsonObj.c_createtime + '</span></div>';
		commentHTML += '<div class="col-40"><span class="pet-comment-answer" onclick="Focus.popupComment(' + jsonObj.c_id + ',' + jsonObj.c_userid + ');"><i class="iconfont">&#xe608;</i>回复</span></div>';
		commentHTML += '</div>';
		commentHTML += '</div>';
		return commentHTML;
	},
	/**
	 * 关注／取消关注
	 *  noticeId 寻宠记录的ID
	 *  flag( 1关注  0取消关注)
	 */
	'setCare' : function(noticeId, flag) {
		if (globalVar.uuid == null) {
			petKiki.confirm('马上去注册／登录？', '登录后才能关注', function() {
				mainView.router.loadPage("html/user/login.html");
			});
		} else {
			window.Auto517.Ajax.ajaxBus({
				url : globalVar.serverAddress + '/findpetcare/careOrCancelNotice.jhtml?fromChannel=app',
				dataType : 'json',
				timeout : 150000,
				data : {
					c_userid : globalVar.uuid,
					c_noticeid : noticeId,
					flag : flag
				},
				type : 'post',
				success : function(data) {
					if (flag == 1) {
						$$('#findPetCare').html('<div onclick="Disvovery.setCare(' + noticeId + ', 0)"><i class="iconfont" style="font-size: 18px;">&#xe60d;</i>已关注</div>');
					} else {
						$$('#findPetCare').html('<div onclick="Disvovery.setCare(' + noticeId + ', 1)"><i class="iconfont" style="font-size: 18px;">&#xe61b;</i>未关注</div>');
					}

				}
			});
		}
	},
	"refreshBack2Myfocus" : function() {
		mainView.router.back({
			"url" : "html/user/myfocus/myfocus.html",
			"force" : true
		});
	},
}